/**
 * MyGraphicsView.java
 * Group 7, Object Oriented Software Engineering
 * Nov 3, 2009
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard;

import com.trolltech.qt.core.QPointF;
import com.trolltech.qt.gui.QGraphicsItemInterface;
import com.trolltech.qt.gui.QGraphicsTextItem;
import com.trolltech.qt.gui.QGraphicsView;
import com.trolltech.qt.gui.QPainter;
import com.trolltech.qt.gui.QPixmap;

/**
 * @author Jesse Yates
 *         Graphics view that should be able to handle input/output of image - doesnt yet
 */
public class DrawingGraphicsView extends QGraphicsView
{

	/**
	 * Constructor
	 * 
	 * @param model
	 *        the model for this view
	 */
	public DrawingGraphicsView(DrawingGraphicsScene model)
	{
		super(model);
		model.changed.connect(this, "center()");
		// this.setHorizontalScrollBarPolicy(Qt.ScrollBarPolicy.ScrollBarAlwaysOff);
		// this.setVerticalScrollBarPolicy(Qt.ScrollBarPolicy.ScrollBarAlwaysOff);

	}

	/**
	 * Open an image from a file name - will populating the model from a string
	 * 
	 * @param fileName
	 *        The string to get the information from
	 */
	public void openImage(String fileName)
	{
		// TODO Auto-generated method stub

	}

	/**
	 * Save the image to the sent fileName
	 * 
	 * @param fileName
	 *        the name of the file to save as
	 * @param fileFormat
	 *        the format of the file to save
	 * @return <code> true</code on success
	 */
	public boolean saveImage(String fileName, String fileFormat)
	{
		getImage().save(fileName, fileFormat);

		return true;
	}

	/**
	 * Get the current image display
	 * 
	 * @return <code>QPixmap</code> of the current view
	 */
	public QPixmap getImage()
	{
		QPixmap pixmap = null;
		QPainter painter = new QPainter(pixmap);
		painter.setRenderHint(QPainter.RenderHint.Antialiasing);
		this.scene().render(painter);
		painter.end();
		return pixmap;
	}

	/**
	 * Centers the view on (0,0) in scene coordinates
	 */
	public void center()
	{
		this.centerOn(new QPointF(this.mapFromScene(new QPointF(0, 0))));
	}

	/**
	 * Get the concatenation of the all the strings in the scene
	 * 
	 * @return
	 */
	public String getStrings()
	{
		StringBuffer ret = new StringBuffer();
		for(QGraphicsItemInterface i : this.scene().items())
		{
			if(i instanceof DrawingTextItem || i instanceof QGraphicsTextItem)
			{
				ret.append(((QGraphicsTextItem) i).toPlainText());
				ret.append("\n");
			}
		}
		ret.trimToSize();
		return ret.toString();
	}
}
