/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard;

import com.trolltech.qt.gui.QRadioButton;

/**
 * @author Jesse Yates
 *         Radio button that has a DrawingType
 */
public class DrawingRadioButton extends QRadioButton implements DrawingButton
{
	private DrawingType type;

	/**
	 * Constructor
	 * 
	 * @param name
	 *        The name of the button to display
	 * @param type
	 *        The drawingType associated with this button
	 */
	public DrawingRadioButton(String name, DrawingType type)
	{
		super(name);
		this.type = type;
	}

	/**
	 * The current type associated with this button
	 */
	public DrawingType getType()
	{
		return this.type;
	}
}
