/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard;

import com.trolltech.qt.QSignalEmitter;
import com.trolltech.qt.core.Qt;
import com.trolltech.qt.gui.QFocusEvent;
import com.trolltech.qt.gui.QGraphicsItem;
import com.trolltech.qt.gui.QGraphicsSceneMouseEvent;
import com.trolltech.qt.gui.QGraphicsTextItem;

/**
 * @author Jesse Yates
 */
public class DrawingTextItem extends QGraphicsTextItem implements DrawingItem
{
	/**
	 * Signal to indicate that it is the item that has lostFocus
	 */
	public final QSignalEmitter.Signal1<DrawingTextItem> lostFocus = new QSignalEmitter.Signal1<DrawingTextItem>();
	/**
	 * Signal to indicate that is has received a mouse press event
	 */
	private final QSignalEmitter.Signal1<QGraphicsSceneMouseEvent> mousePressEvent = new QSignalEmitter.Signal1<QGraphicsSceneMouseEvent>();

	/**
	 * Constructor that creates item with sent <code>String</code>
	 * 
	 * @param string
	 *        The string to initialize the element with
	 */
	public DrawingTextItem(String string)
	{
		super(string);
		this.setFlag(QGraphicsItem.GraphicsItemFlag.ItemIsMovable, true);
		this.setFlag(QGraphicsItem.GraphicsItemFlag.ItemIsSelectable, true);

	}

	/**
	 * Called when the item has lost focus - emit the <code>lostFocus</code> signal
	 */
	public void focusOutEvent(QFocusEvent event)
	{
		System.out.println("LostFocus: " + this);
		this.setTextInteractionFlags(Qt.TextInteractionFlag.NoTextInteraction);
		this.setFlag(QGraphicsItem.GraphicsItemFlag.ItemIsMovable, false);
		lostFocus.emit(this);

	}

	/**
	 * Handles the mousePressEvent that occurs on the object
	 */
	public void mousePressEvent(QGraphicsSceneMouseEvent event)
	{
		System.out.println("\t\tText mouse click!");
		super.setTextInteractionFlags(Qt.TextInteractionFlag.TextEditorInteraction);
		this.setFlag(QGraphicsItem.GraphicsItemFlag.ItemIsMovable, true);
		super.mousePressEvent(event);
		event.accept();
	}

	/**
	 * Handles the doubleClick events that are sent to the object
	 */
	public void mouseDoubleClickEvent(QGraphicsSceneMouseEvent event)
	{
		System.out.println("\t\tText DOUBLE mouse click!");
		// this.setFlag(QGraphicsItem.GraphicsItemFlag.ItemIsMovable, false);
		// System.out.println("Double click event!");
		// this.setFlag(QGraphicsItem.GraphicsItemFlag.ItemIsMovable, true);
		// super.setTextInteractionFlags(Qt.TextInteractionFlag.TextEditorInteraction);
		// super.mouseDoubleClickEvent(event);
		// super.mouseDoubleClickEvent(event);
		event.accept();
		// super.setTextInteractionFlags(Qt.TextInteractionFlag.TextEditorInteraction);
		// this.scene().clear();
		// super.mousePressEvent(event);
		// event.accept();
		/*
		QGraphicsSceneMouseEvent mouseEvent = new QGraphicsSceneMouseEvent(QEvent.Type.GraphicsSceneMousePress);
		mouseEvent.accept();
		mouseEvent.setPos(event.pos());
		mouseEvent.setScenePos(event.scenePos());
		mouseEvent.setScreenPos(event.screenPos());
		mouseEvent.setButtonDownPos(Qt.MouseButton.LeftButton, event.buttonDownPos(Qt.MouseButton.LeftButton));
		mouseEvent.setButtonDownScreenPos(Qt.MouseButton.LeftButton, event.buttonDownScreenPos(Qt.MouseButton.LeftButton));
		mouseEvent.setButtonDownScenePos(Qt.MouseButton.LeftButton, event.buttonDownScenePos(Qt.MouseButton.LeftButton));
		mouseEvent.setButtons(event.buttons());

		super.mousePressEvent(mouseEvent);
		*/
	}

	/*
	public void keyPressEvent(QKeyEvent event)
	{
		System.out.println("Key event!");
		String current = new String(this.toPlainText());
		super.keyPressEvent(event);
		if(!this.toHtml().equals(current))
		{
			String added = this.toPlainText();
			this.setHtml(current);
			((DefaultCanvasScene) this.scene()).addEvent(new AddTextCommand(this, current, added));
		}
	}*/

	public String toString()
	{
		StringBuffer out = new StringBuffer();
		out.append("Text:");
		out.append(this.toPlainText());
		out.append(",loc:");
		out.append(this.scenePos());
		return out.toString();
	}

	public void buildFromString(String s)
	{
		System.out.println("Building from: " + s);
		this.setPlainText(s.substring(s.indexOf(":") + 1, s.indexOf(",")));
		s = s.substring(s.indexOf("(") + 1, s.indexOf(")"));
		System.out.println("s=" + s);
		Double x = new Double(s.substring(0, s.indexOf(",")));
		Double y = new Double(s.substring(s.indexOf(",") + 2));
		this.setPos(x, y);

	}
}
