/**
 * 
 */
package edu.jhu.cs.oose.elevel.AdvancedEditCard;

import com.trolltech.qt.QSignalEmitter;
import com.trolltech.qt.gui.QFocusEvent;
import com.trolltech.qt.gui.QTextEdit;

/**
 * @author Jesse Yates
 */
public class FocusingTextEdit extends QTextEdit
{
	/** Indicates if the element has gained focus */
	public final QSignalEmitter.Signal0 gainedFocus = new QSignalEmitter.Signal0();
	public final QSignalEmitter.Signal0 lostFocus = new QSignalEmitter.Signal0();

	public FocusingTextEdit(String text)
	{
		super(text);
	}

	protected void focusInEvent(QFocusEvent event)
	{
		super.focusInEvent(event);
		this.gainedFocus.emit();
	}

	protected void focusOutEvent(QFocusEvent event)
	{
		super.focusOutEvent(event);
		this.lostFocus.emit();
	}

	public void focusUndo()
	{
		if(this.hasFocus())
			super.redo();
	}

	public void focusRedo()
	{
		if(this.hasFocus())
			super.redo();
	}
}
